#############################################################################################
#File version 1.3 07.03.12
#
#This file is a part of 
# Molecular Modeling Visualization Scripts Library
#
#Developed by Grigoriy Armeev and Alexey Shaytan
#Copyright (c) 2012 Molecular Simulations Group, Lomonosov Moscow State University
#
#for more information visit http://www.molsim.org
#mail at info@molsim.org
#############################################################################################
# This script changes colors in Resname coloring method to colors scaled by hydrophobicity.
#
#
#
# Here we put Amino acids hydrophobicity scale according to Shaytan et al. DOI: 10.1021/bm8015169,Table 2d
# It was rescaled from zero to one due to featured universal usage of this code
set aa(TRP) 1.000
set aa(ILE) 0.890
set aa(PHE) 0.886
set aa(LEU) 0.861
set aa(MET) 0.749
set aa(VAL) 0.745
set aa(CYS) 0.696
set aa(TYR) 0.682
set aa(PRO) 0.495
set aa(ALA) 0.521
set aa(THR) 0.508
set aa(HIS) 0.477
set aa(GLY) 0.445
set aa(SER) 0.436
set aa(GLN) 0.391
set aa(ASN) 0.302
set aa(LYS) 0.201
set aa(ARG) 0.197
set aa(GLU) 0.020
set aa(ASP) 0.000

# Here we put colors for the most hydrophilic and hydrophobic aminoacids in standart hex
set hydrophil_color "#0048FF"
set hydrophob_color "#FFE300"

# convert one hex variable into 3 decimal
scan $hydrophil_color "#%2x%2x%2x" r0 g0 b0
scan $hydrophob_color "#%2x%2x%2x" r1 g1 b1
# now let's make colors acceptable for vmd
set r0 [expr {double($r0)/255} ]
set r1 [expr {double($r1)/255} ]
set g0 [expr {double($g0)/255} ]
set g1 [expr {double($g1)/255} ]
set b0 [expr {double($b0)/255} ]
set b1 [expr {double($b1)/255} ]

# Apply colors for aminoacids, starting with 40, because we don't want to mess with standart 32 colors
set num 40
foreach i [lsort [array names aa] ] {
color Resname $i $num
color change rgb $num [expr $r0+$aa($i)*($r1-$r0)] [expr $g0+$aa($i)*($g1-$g0)] [expr $b0+$aa($i)*($b1-$b0)]
incr num 1
}

