#############################################################################################
#File version 1.0 07.03.12
#
#This file is a part of 
# Molecular Modeling Visualization Scripts Library
#
#Developed by Grigoriy Armeev and Alexey Shaytan
#Copyright (c) 2012 Molecular Simulations Group, Lomonosov Moscow State University
#
#for more information visit http://www.molsim.org
#mail at info@molsim.org
#############################################################################################
#
# NOTICE: it places the bar in coordinates defined for current molecule
#
#----------procedure draws a color scale bar with legend--------
# usage: colorbar length width x_position y_position red_color_bottom red_color_top green_color_bottom green_color_top blue_color_bottom blue_color_top scalesteps scalemin scalemax
# where scalestaeps defines number of steps for scale
# scalemin and scalemax are minimum and maximum scale numbers
# example:
# colorbar 200 20 -380 -100 0 1 1 0 0 0 11 -2.5 3.0
# will draw you a green-to-red bar with scale from -2.5 to 3 with 0.5 step
# it will be 200 px high and 20 px width, it's bottom left corner wil be on -380 -100 px
#
#

proc colorbar {length width posx posy r0 r1 g0 g1 b0 b1 scalesteps scalemin scalemax} {
display update off

set lines 400 
for {set n 0} {$n < $lines} {incr n 1} {
color change rgb [expr 1024-$lines+$n] [expr {$r0+(double($n)/($lines-1))*($r1-$r0)}] [expr {$g0+(double($n)/($lines-1))*($g1-$g0)}] [expr {$b0+(double($n)/($lines-1))*($b1-$b0)}]
draw color [expr 1024-$lines+$n]
draw line " $posx [expr {$posy+(double($n)/($lines-1)*$length)} ] 0 " " [expr $posx + $width] [expr {$posy+(double($n)/($lines-1)*$length)} ] 0 " width 2
}
#draws legend and frame for bar
draw color 16
draw line " $posx $posy 0 " " [expr $posx + $width + 10] $posy 0" width 2
draw text " [expr $posx + $width + 15] [expr $posy-0] 0 " "[format "% .1f" $scalemin] " size 1 thickness 1

draw line " $posx [expr $posy+$length] 0 " " [expr $posx + $width + 10] [expr $posy+$length] 0" width 2
draw text " [expr $posx + $width + 15] [expr $posy+$length-0] 0 " "[format "% .1f" $scalemax] " size 1 thickness 1

draw line " $posx $posy 0 " " $posx [expr $posy+$length] 0" width 2
draw line " [expr $posx + $width] $posy 0 " " [expr $posx + $width] [expr $posy+$length] 0" width 2

for {set n 1} {$n < $scalesteps} {incr n 1} {
draw line " [expr $posx + $width] [expr $posy+(double($n)/$scalesteps)*$length] 0 " "[expr $posx + $width + 5] [expr $posy+(double($n)/$scalesteps)*$length] 0 "
draw text " [expr $posx + $width + 15] [expr $posy+(double($n)/$scalesteps)*$length-0] 0 " "[format "% .1f" [expr $scalemin+$n*($scalemax-$scalemin)/$scalesteps]]" size 1 thickness 1
}
display update on
}